Story # 54268 (Resolved): As an TYPO3-Contributor I want to have a clean CodeBase in order maintain the product
Subject: Refactor Driver API
Description

The Driver is a concept to just encapsulate the Filesystem access...
It should not know about FileObject or FolderObjects... A filesystem only knows about its Identifiers.

The connection to the FAL Object world happens in the ResourceStorage.

Refactor the Driver to only act on Identifiers and define an Interface for that, replace all type-hints for abstract Driver to use the
interface

Related issues:
related to Core - Bug # 57415: Local driver does not sanitize directory names... Resolved 2014-03-28
related to Core - Task # 53770: ResourceStorage uses deprecated driver API Resolved 2013-11-19
related to Core - Task # 55416: Accessing the root folder of a file mount is ... Resolved 2014-01-29
precedes Core - Task # 54231: The Driver Registry should check for the implem... Resolved 2014-01-01 2014-01-01

Associated revisions
Revision f83eddd5 - 2014-01-15 14:57 - Steffen Ritter

[!!!][TASK] Driver API has too many crosscutting concerns

The Driver within the FileAbstractionLayer is the actual
abstraction of a concrete file-system meant to unify
access to several kind of storage-systems the file data
might reside in. For each way of storing files there
has to be a driver.

Therefore a driver is solely a unique API to interact with
an underlying storage system based upon its own identifier
system.

Opposite to that, the AbstractDriver (defining our Interface)
knows about its storage, file- and folder-objects as well
as indexes. The methods within the current driver need to
implement more FAL-internal logic than one would expect from
what the driver is purposed to. As a result only a few drivers
are existing by now. In addition it's nearly impossible to
change FAL interals without touching every driver out there.
This change deals with these problems. In several steps the
current driver API has been refactored to have less dependencies
and only fullfills it's original purpose: the abstraction of a
file storage system.

The following things are considered:
   1. Change every return value which has been an object to the
      identifier and adapt the ResourceStorage accordingly.
   2. Change every method parameter being FileInterface, File,
      AbstractFile or Folder objects to a string: the identifier.
   3. Get rid of the storage as a member variable, only the uid
      of the storage is needed at two places.
   4. Remove all abstract methods from the AbstractDriver and
      put them in a newly created DriverInterface.
   5. Exchange all references to AbstractDriver to the interface.
   6. Remove unused methods, which came to light doing so.
   7. Merge addFile/removeFile and *Raw since the do the same if
      no objects are in place.
   8. Unify the creation of folder objects and how information
      is retrieved (analogue to files now).
   9. Unify and simplify the methods for retrieving folder
      contents (files / folders).
  10. Adapt the UnitTests of both classes to the changes.
      This also leads to the removal of some tests which are
      superfluous with that change.
  11. Make the DriverRegistry check the implementation of the
      newly created interface.
  12. Unify the parameter names in the methods.

Releases: 6.2
Resolves: #54230
Resolves: #54231
Change-Id: I4a51572c6a10859e6fd5f12f6cb539950444992e
Reviewed-on: https://review.typo3.org/26520
Reviewed-by: Frans Saris
Tested-by: Frans Saris
Reviewed-by: Benjamin Mack
Tested-by: Benjamin Mack

Revision 84b6e61f - 2014-01-15 15:57 - Steffen Ritter

[TASK] Skip two tests in LocalDriverTests in PHP 5.3

For most tests in the LocalDriverTest vfsStream is used to
emulate the filesystem. This needs PHP filesystem functions
to use the stream wrappers.

For touch() this has been enabled with PHP 5.4. The reversal
conclusion is, that this does not work with PHP 5.3 which
causes failing tests there.

As a result If the PHP version is 5.3 we skip the two tests.
This is a follow-up to https://review.typo3.org/#/c/26520/

Resolves: #54230
Releases: 6.2
Change-Id: I4e92927e1d77f825bab8583318a944a8916051d5
Reviewed-on: https://review.typo3.org/26845
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History
#1 - 2013-12-07 16:08 - Steffen Ritter
- Parent task set to #54268

#2 - 2013-12-20 15:56 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#3 - 2013-12-20 16:15 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#4 - 2013-12-20 17:49 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#5 - 2013-12-21 19:02 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#6 - 2013-12-22 10:24 - Steffen Ritter
- % Done changed from 0 to 70

#7 - 2014-01-05 16:35 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#8 - 2014-01-05 20:29 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520
#9 - 2014-01-09 15:34 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#10 - 2014-01-09 23:02 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#11 - 2014-01-14 12:42 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#12 - 2014-01-15 10:01 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#13 - 2014-01-15 14:09 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26520

#14 - 2014-01-15 15:30 - Steffen Ritter
- Status changed from Under Review to Resolved
- % Done changed from 70 to 100

Applied in changeset commit:f83eddd5027b74d7f4d28a845521bff3b2dd603d.

#15 - 2014-01-15 15:40 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26845

#16 - 2014-01-15 16:30 - Steffen Ritter
- Status changed from Under Review to Resolved

Applied in changeset commit:84b6e61fa61592f4d704846fa5292ab58773851d.
#17 - 2014-01-15 16:36 - Steffen Ritter
- % Done changed from 100 to 90

#18 - 2014-02-17 08:47 - Steffen Ritter
- % Done changed from 90 to 100
